<template>
    <div class="col-12">
        <table class="table table-hover" v-if="absenceTotal>0">
            <thead>
                <tr>
                    <th>Utilisateur</th>
                    <th>Date de demande</th>
                    <th>Début</th>
                    <th>Fin</th>
                    <th>Type</th>
                    <th v-if="displayChecked">Valide</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody v-for="user in users">
                <tr v-for="(absence,index) in user.absences" v-if="!absence.checked || displayChecked">
                    <td>{{user.firstname}} {{user.lastname}}</td>
                    <td>{{absence.requestdate | formatdate}}</td>
                    <td>{{absence.startdate | formatdate}}</td>
                    <td>{{absence.enddate | formatdate}}</td>
                    <td>{{absence.type}}</td>
                    <td v-if="displayChecked">
                        <span v-if="absence.valid">Valide</span>
                        <span v-if="!absence.valid">Non Validee</span>
                    </td>
                    <td>
                        <button class="btn btn-success but" v-if="canValidate" v-on:click="valider(user,index)">Valider</button>
                        <button class="btn btn-danger but" v-if="canValidate" v-on:click="refuser(user,index)">Refuser</button>
                        <button class="btn btn-primary but" v-if="canEdit && !absence.checked" v-on:click="edit(user,index)">Modifier</button>
                    </td>
                </tr>
    
            </tbody>
        </table>
        <h2 v-else>Aucune Absence a Afficher</h2>
    </div>
</template>


<script>
import Moment from "moment";
export default {
    props: [
        "users",
        "canEdit",
        "canValidate",
        "displayChecked"
    ],
    methods: {
        valider: function (user, absence) {
            this.$emit("valider", { user, absence });
        },
        refuser: function (user, absence) {
            this.$emit("refuser", { user, absence });
        },
        edit: function (user, absence) {
            this.$emit("edit", { user, absence });
        }
    },
    computed: {
        absenceTotal() {
            let total = 0;
            if (this.users) {
                this.users.forEach((u) => {
                    if (u.absences) {
                        u.absences.forEach((a) => {
                            total++;
                        });
                    }
                }, this);
            }
            return total;
        }
    }
}
</script>

<style>
th {
    text-align: center;
}
</style>
